# std::is_class

From cppreference.com
< cpp‎ | types

Defined in header `<type_traits>` |  |
template< class T > struct is_class; |  | (since C++11)

Checks whether `T` is a non-union class type. Provides the member constant `value` which is equal to true, if `T` is a class type (but not union). Otherwise, `value` is equal to false.

### Template parameters

T | - | a type to check

### Helper variable template

template< class T > inline constexpr bool is_class_v = is_class<T>::value; |  | (since C++17)

## Inherited from std::integral_constant

### Member constants

value [static] | true if `T` is a non-union class type , false otherwise (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant<bool, value>

### Possible implementation

    namespace detail {
        template <class T> char test(int T::*);
        struct two { char c[2]; };
        template <class T> two test(...);
    }

    template <class T>
    struct is_class : std::integral_constant<bool, sizeof(detail::test<T>(0))==1
                                                && !std::is_union<T>::value> {};

### Example

Run this code

    #include <iostream>
    #include <type_traits>

    struct A {};

    class B {};

    enum class C {};

    int main()
    {
        std::cout << std::boolalpha;
        std::cout << std::is_class<A>::value << '\n';
        std::cout << std::is_class<B>::value << '\n';
        std::cout << std::is_class<C>::value << '\n';
        std::cout << std::is_class<int>::value << '\n';
    }

Output:

    true
    true
    false
    false

### See also

is_union (C++11) | checks if a type is an union type (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/types/is_class&oldid=110844"